diff --git a/gcc/dwarf2out.c b/gcc/dwarf2out.c
index 2b584a5..d11ae04 100644
--- a/gcc/dwarf2out.c
+++ b/gcc/dwarf2out.c
@@ -21985,7 +21985,7 @@ output_macinfo (void)
 	  break;
 	case DW_MACINFO_define:
 	case DW_MACINFO_undef:
-	  if (!dwarf_strict
+	  if (!GCC_OPTION (dwarf_strict)
 	      && HAVE_COMDAT_GROUP
 	      && vec_safe_length (files) != 1
 	      && i > 0
@@ -22101,7 +22101,7 @@ dwarf2out_init (const char *filename ATTRIBUTE_UNUSED)
 
   vec_alloc (used_rtx_array, 32);
 
-  if (!dwarf_split_debug_info)
+  if (!GCC_OPTION (dwarf_split_debug_info))
     {
       debug_info_section = get_section (DEBUG_INFO_SECTION,
                                         SECTION_DEBUG, NULL);
@@ -22145,7 +22145,7 @@ dwarf2out_init (const char *filename ATTRIBUTE_UNUSED)
     }
   debug_aranges_section = get_section (DEBUG_ARANGES_SECTION,
 				       SECTION_DEBUG, NULL);
-  debug_macinfo_section = get_section (dwarf_strict
+  debug_macinfo_section = get_section (GCC_OPTION (dwarf_strict)
 				       ? DEBUG_MACINFO_SECTION
 				       : DEBUG_MACRO_SECTION,
                                        DEBUG_MACRO_SECTION_FLAGS, NULL);
@@ -22179,12 +22179,12 @@ dwarf2out_init (const char *filename ATTRIBUTE_UNUSED)
   ASM_GENERATE_INTERNAL_LABEL (debug_addr_section_label,
                                DEBUG_ADDR_SECTION_LABEL, 0);
   ASM_GENERATE_INTERNAL_LABEL (macinfo_section_label,
-			       dwarf_strict
+			       GCC_OPTION (dwarf_strict)
 			       ? DEBUG_MACINFO_SECTION_LABEL
 			       : DEBUG_MACRO_SECTION_LABEL, 0);
   ASM_GENERATE_INTERNAL_LABEL (loc_section_label, DEBUG_LOC_SECTION_LABEL, 0);
 
-  if (debug_info_level >= DINFO_LEVEL_VERBOSE)
+  if (GCC_OPTION (debug_info_level) >= DINFO_LEVEL_VERBOSE)
     vec_alloc (macinfo_table, 64);
 
   switch_to_section (text_section);
@@ -22203,7 +22203,7 @@ dwarf2out_assembly_start (void)
 {
   if (HAVE_GAS_CFI_SECTIONS_DIRECTIVE
       && dwarf2out_do_cfi_asm ()
-      && (!(flag_unwind_tables || flag_exceptions)
+      && (!(GCC_OPTION (flag_unwind_tables) || GCC_OPTION (flag_exceptions))
 	  || targetm_common.except_unwind_info (&global_options) != UI_DWARF2))
     fprintf (asm_out_file, "\t.cfi_sections\t.debug_frame\n");
 }
@@ -22296,7 +22296,7 @@ static void
 output_indirect_strings (void)
 {
   switch_to_section (debug_str_section);
-  if (!dwarf_split_debug_info)
+  if (!GCC_OPTION (dwarf_split_debug_info))
     htab_traverse (debug_str_hash, output_indirect_string, NULL);
   else
     {
@@ -23081,7 +23081,7 @@ resolve_addr_in_expr (dw_loc_descr_ref loc)
 		 || prev->dw_loc_opc == DW_OP_bit_piece)
 		&& loc->dw_loc_next
 		&& loc->dw_loc_next->dw_loc_opc == DW_OP_stack_value
-		&& !dwarf_strict
+		&& !GCC_OPTION (dwarf_strict)
 		&& optimize_one_addr_into_implicit_ptr (loc))
 	      break;
 	    return false;
@@ -23215,7 +23215,7 @@ optimize_location_into_implicit_ptr (dw_die_ref die, tree decl)
      DW_AT_const_value instead.  */
   if (tree_add_const_value_attribute (die, init))
     return;
-  if (dwarf_strict)
+  if (GCC_OPTION (dwarf_strict))
     return;
   /* If init is ADDR_EXPR or POINTER_PLUS_EXPR of ADDR_EXPR,
      and ADDR_EXPR refers to a decl that has DW_AT_location or
@@ -23310,7 +23310,7 @@ resolve_addr (dw_die_ref die)
 			gcc_assert (!next->ll_symbol);
 			next->ll_symbol = (*curr)->ll_symbol;
 		      }
-                    if (dwarf_split_debug_info)
+                    if (GCC_OPTION (dwarf_split_debug_info))
                       remove_loc_list_addr_table_entries (l);
 		    *curr = next;
 		  }
@@ -23342,14 +23342,14 @@ resolve_addr (dw_die_ref die)
 	     DW_OP_plus_uconst - older consumers might
 	     rely on it being that op instead of a more complex,
 	     but shorter, location description.  */
-	  if ((dwarf_version > 2
+	  if ((GCC_OPTION (dwarf_version) > 2
 	       || a->dw_attr != DW_AT_data_member_location
 	       || l == NULL
 	       || l->dw_loc_opc != DW_OP_plus_uconst
 	       || l->dw_loc_next != NULL)
 	      && !resolve_addr_in_expr (l))
 	    {
-	      if (dwarf_split_debug_info)
+	      if (GCC_OPTION (dwarf_split_debug_info))
 		remove_loc_list_addr_table_entries (l);
 	      if (l != NULL
 		  && l->dw_loc_next == NULL
@@ -23731,7 +23731,7 @@ compare_loc_operands (dw_loc_descr_ref x, dw_loc_descr_ref y)
         can cause irrelevant differences in dw_loc_addr.  */
       gcc_assert (valx1->val_class == dw_val_class_loc
 		  && valy1->val_class == dw_val_class_loc
-                  && (dwarf_split_debug_info
+                  && (GCC_OPTION (dwarf_split_debug_info)
                       || x->dw_loc_addr == y->dw_loc_addr));
       return valx1->v.val_loc->dw_loc_addr == valy1->v.val_loc->dw_loc_addr;
     case DW_OP_implicit_value:
@@ -24054,7 +24054,7 @@ dwarf2out_finish (const char *filename)
       /* When generating LTO bytecode we can not generate new assembler
          names at this point and all important decls got theirs via
 	 free-lang-data.  */
-      if ((!flag_generate_lto || DECL_ASSEMBLER_NAME_SET_P (decl))
+      if ((!GCC_OPTION (flag_generate_lto) || DECL_ASSEMBLER_NAME_SET_P (decl))
 	  && DECL_ASSEMBLER_NAME (decl) != DECL_NAME (decl))
 	{
 	  add_linkage_attr (node->die, decl);
@@ -24068,7 +24068,7 @@ dwarf2out_finish (const char *filename)
      emit full debugging info for them.  */
   retry_incomplete_types ();
 
-  if (flag_eliminate_unused_debug_types)
+  if (GCC_OPTION (flag_eliminate_unused_debug_types))
     prune_unused_types ();
 
   /* Generate separate COMDAT sections for type DIEs. */
@@ -24096,7 +24096,7 @@ dwarf2out_finish (const char *filename)
 
   /* Generate separate CUs for each of the include files we've seen.
      They will go into limbo_die_list.  */
-  if (flag_eliminate_dwarf2_dups)
+  if (GCC_OPTION (flag_eliminate_dwarf2_dups))
     break_out_includes (comp_unit_die ());
 
   /* Traverse the DIE's and add add sibling attributes to those DIE's
@@ -24110,7 +24110,7 @@ dwarf2out_finish (const char *filename)
   /* When splitting DWARF info, we put some attributes in the
      skeleton compile_unit DIE that remains in the .o, while
      most attributes go in the DWO compile_unit_die.  */
-  if (dwarf_split_debug_info)
+  if (GCC_OPTION (dwarf_split_debug_info))
     main_comp_unit_die = gen_compile_unit_die (NULL);
   else
     main_comp_unit_die = comp_unit_die ();
@@ -24127,7 +24127,7 @@ dwarf2out_finish (const char *filename)
   /* We can only use the low/high_pc attributes if all of the code was
      in .text.  */
   if (!have_multiple_function_sections 
-      || (dwarf_version < 3 && dwarf_strict))
+      || (GCC_OPTION (dwarf_version) < 3 && GCC_OPTION (dwarf_strict)))
     {
       /* Don't add if the CU has no associated code.  */
       if (text_section_used)
@@ -24169,23 +24169,23 @@ dwarf2out_finish (const char *filename)
 	     DW_AT_entry_pc instead of DW_AT_low_pc for this purpose.
 	     Emit both to give time for other tools to adapt.  */
           add_AT_addr (main_comp_unit_die, DW_AT_low_pc, const0_rtx, true);
-	  if (! dwarf_strict && dwarf_version < 4)
+	  if (! GCC_OPTION (dwarf_strict) && GCC_OPTION (dwarf_version) < 4)
             add_AT_addr (main_comp_unit_die, DW_AT_entry_pc, const0_rtx, true);
 
 	  add_ranges (NULL);
 	}
     }
 
-  if (debug_info_level >= DINFO_LEVEL_TERSE)
+  if (GCC_OPTION (debug_info_level) >= DINFO_LEVEL_TERSE)
     add_AT_lineptr (main_comp_unit_die, DW_AT_stmt_list,
 		    debug_line_section_label);
 
   if (have_macinfo)
     add_AT_macptr (comp_unit_die (),
-		   dwarf_strict ? DW_AT_macro_info : DW_AT_GNU_macros,
+		   GCC_OPTION (dwarf_strict) ? DW_AT_macro_info : DW_AT_GNU_macros,
 		   macinfo_section_label);
 
-  if (dwarf_split_debug_info && addr_index_table != NULL)
+  if (GCC_OPTION (dwarf_split_debug_info) && addr_index_table != NULL)
     {
       /* optimize_location_lists calculates the size of the lists,
          so index them first, and assign indices to the entries.
@@ -24202,7 +24202,7 @@ dwarf2out_finish (const char *filename)
 
   save_macinfo_strings ();
 
-  if (dwarf_split_debug_info)
+  if (GCC_OPTION (dwarf_split_debug_info))
     {
       unsigned int index = 0;
 
@@ -24233,9 +24233,9 @@ dwarf2out_finish (const char *filename)
       /* Add a pointer to the line table for the main compilation unit
          so that the debugger can make sense of DW_AT_decl_file
          attributes.  */
-      if (debug_info_level >= DINFO_LEVEL_TERSE)
+      if (GCC_OPTION (debug_info_level) >= DINFO_LEVEL_TERSE)
         add_AT_lineptr (ctnode->root_die, DW_AT_stmt_list,
-                        (!dwarf_split_debug_info
+                        (!GCC_OPTION (dwarf_split_debug_info)
                          ? debug_line_section_label
                          : debug_skeleton_line_section_label));
 
@@ -24248,10 +24248,10 @@ dwarf2out_finish (const char *filename)
      both the main_cu and all skeleton TUs.  Making this call unconditional
      would end up either adding a second copy of the AT_pubnames attribute, or
      requiring a special case in add_top_level_skeleton_die_attrs.  */
-  if (!dwarf_split_debug_info)
+  if (!GCC_OPTION (dwarf_split_debug_info))
     add_AT_pubnames (comp_unit_die ());
 
-  if (dwarf_split_debug_info)
+  if (GCC_OPTION (dwarf_split_debug_info))
     {
       int mark;
       unsigned char checksum[16];
@@ -24284,7 +24284,7 @@ dwarf2out_finish (const char *filename)
      or .debug_macro will be emitted.  */
   output_comp_unit (comp_unit_die (), have_macinfo);
 
-  if (dwarf_split_debug_info && info_section_emitted)
+  if (GCC_OPTION (dwarf_split_debug_info) && info_section_emitted)
     output_skeleton_debug_sections (main_comp_unit_die);
 
   /* Output the abbreviation table.  */
@@ -24347,7 +24347,7 @@ dwarf2out_finish (const char *filename)
   if (! DWARF2_ASM_LINE_DEBUG_INFO)
     output_line_info (false);
 
-  if (dwarf_split_debug_info && info_section_emitted)
+  if (GCC_OPTION (dwarf_split_debug_info) && info_section_emitted)
     {
       switch_to_section (debug_skeleton_line_section);
       ASM_OUTPUT_LABEL (asm_out_file, debug_skeleton_line_section_label);
diff --git a/gcc/emit-rtl.c b/gcc/emit-rtl.c
index 4736f8d..3cc5bbd 100644
--- a/gcc/emit-rtl.c
+++ b/gcc/emit-rtl.c
@@ -3777,7 +3777,7 @@ add_insn_after_nobb (rtx insn, rtx after)
 {
   rtx next = NEXT_INSN (after);
 
-  gcc_assert (!optimize || !INSN_DELETED_P (after));
+  gcc_assert (!GCC_OPTION (optimize) || !INSN_DELETED_P (after));
 
   link_insn_into_chain (insn, after, next);
 
@@ -3806,7 +3806,7 @@ add_insn_before_nobb (rtx insn, rtx before)
 {
   rtx prev = PREV_INSN (before);
 
-  gcc_assert (!optimize || !INSN_DELETED_P (before));
+  gcc_assert (!GCC_OPTION (optimize) || !INSN_DELETED_P (before));
 
   link_insn_into_chain (insn, prev, before);
 
diff --git a/gcc/except.c b/gcc/except.c
index 908954c..c1b2e52 100644
--- a/gcc/except.c
+++ b/gcc/except.c
@@ -234,7 +234,7 @@ static void sjlj_output_call_site_table (void);
 void
 init_eh (void)
 {
-  if (! flag_exceptions)
+  if (! GCC_OPTION (flag_exceptions))
     return;
 
   type_to_runtime_map = htab_create_ggc (31, t2r_hash, t2r_eq, NULL);
@@ -1012,7 +1012,7 @@ dw2_build_landing_pads (void)
      new landing pads later, which means that we need to hold on to
      the post-landing-pad block.  Prevent it from being merged away.
      We'll remove this bit after partitioning.  */
-  if (flag_reorder_blocks_and_partition)
+  if (GCC_OPTION (flag_reorder_blocks_and_partition))
     e_flags |= EDGE_PRESERVE;
 
   for (i = 1; vec_safe_iterate (cfun->eh->lp_array, i, &lp); ++i)
@@ -1723,7 +1723,7 @@ make_reg_eh_region_note_nothrow_nononlocal (rtx insn)
 bool
 insn_could_throw_p (const_rtx insn)
 {
-  if (!flag_exceptions)
+  if (!GCC_OPTION (flag_exceptions))
     return false;
   if (CALL_P (insn))
     return true;
@@ -1968,7 +1968,7 @@ set_nothrow_function_flags (void)
   if (TREE_NOTHROW (current_function_decl))
     return 0;
 
-  if (! flag_exceptions)
+  if (! GCC_OPTION (flag_exceptions))
     return 0;
 
   for (insn = get_insns (); insn; insn = NEXT_INSN (insn))
@@ -2588,7 +2588,7 @@ convert_to_eh_region_ranges (void)
 	     && NOTE_KIND (iter) == NOTE_INSN_SWITCH_TEXT_SECTIONS)
       {
 	gcc_assert (section_switch_note == NULL_RTX);
-	gcc_assert (flag_reorder_blocks_and_partition);
+	gcc_assert (GCC_OPTION (flag_reorder_blocks_and_partition));
 	section_switch_note = iter;
 	if (first_no_action_insn)
 	  {
@@ -2841,7 +2841,7 @@ switch_to_exception_section (const char * ARG_UNUSED (fnname))
 	    {
 	      int tt_format =
 		ASM_PREFERRED_EH_DATA_FORMAT (/*code=*/0, /*global=*/1);
-	      flags = ((! flag_pic
+	      flags = ((! GCC_OPTION (flag_pic)
 			|| ((tt_format & 0x70) != DW_EH_PE_absptr
 			    && (tt_format & 0x70) != DW_EH_PE_aligned))
 		       ? 0 : SECTION_WRITE);
@@ -2850,7 +2850,7 @@ switch_to_exception_section (const char * ARG_UNUSED (fnname))
 	    flags = SECTION_WRITE;
 
 #ifdef HAVE_LD_EH_GC_SECTIONS
-	  if (flag_function_sections
+	  if (GCC_OPTION (flag_function_sections)
 	      || (DECL_ONE_ONLY (current_function_decl) && HAVE_COMDAT_GROUP))
 	    {
 	      char *section_name = XNEWVEC (char, strlen (fnname) + 32);
@@ -2869,7 +2869,7 @@ switch_to_exception_section (const char * ARG_UNUSED (fnname))
 	}
       else
 	exception_section
-	  = s = flag_pic ? data_section : readonly_data_section;
+	  = s = GCC_OPTION (flag_pic) ? data_section : readonly_data_section;
     }
 
   switch_to_section (s);
diff --git a/gcc/explow.c b/gcc/explow.c
index f4df9df..4f60a9e 100644
--- a/gcc/explow.c
+++ b/gcc/explow.c
@@ -565,7 +565,7 @@ use_anchored_address (rtx x)
   HOST_WIDE_INT offset;
   enum machine_mode mode;
 
-  if (!flag_section_anchors)
+  if (!GCC_OPTION (flag_section_anchors))
     return x;
 
   if (!MEM_P (x))
@@ -1195,7 +1195,7 @@ allocate_dynamic_stack_space (rtx size, unsigned size_align,
   /* If stack usage info is requested, look into the size we are passed.
      We need to do so this early to avoid the obfuscation that may be
      introduced later by the various alignment operations.  */
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     {
       if (CONST_INT_P (size))
 	stack_usage_size = INTVAL (size);
@@ -1287,7 +1287,7 @@ allocate_dynamic_stack_space (rtx size, unsigned size_align,
       size = plus_constant (Pmode, size, extra);
       size = force_operand (size, NULL_RTX);
 
-      if (flag_stack_usage_info)
+      if (GCC_OPTION (flag_stack_usage_info))
 	stack_usage_size += extra;
 
       if (extra && size_align > extra_align)
@@ -1311,7 +1311,7 @@ allocate_dynamic_stack_space (rtx size, unsigned size_align,
     {
       size = round_push (size);
 
-      if (flag_stack_usage_info)
+      if (GCC_OPTION (flag_stack_usage_info))
 	{
 	  int align = crtl->preferred_stack_boundary / BITS_PER_UNIT;
 	  stack_usage_size = (stack_usage_size + align - 1) / align * align;
@@ -1322,7 +1322,7 @@ allocate_dynamic_stack_space (rtx size, unsigned size_align,
 
   /* The size is supposed to be fully adjusted at this point so record it
      if stack usage info is requested.  */
-  if (flag_stack_usage_info)
+  if (GCC_OPTION (flag_stack_usage_info))
     {
       current_function_dynamic_stack_size += stack_usage_size;
 
@@ -1342,7 +1342,7 @@ allocate_dynamic_stack_space (rtx size, unsigned size_align,
      be released when we release the current stack segment.  The
      effect is that stack allocation becomes less efficient, but at
      least it doesn't cause a stack overflow.  */
-  if (flag_split_stack)
+  if (GCC_OPTION (flag_split_stack))
     {
       rtx available_label, ask, space, func;
 
@@ -1403,10 +1403,10 @@ allocate_dynamic_stack_space (rtx size, unsigned size_align,
      account what has already been checked.  */
   if (STACK_CHECK_MOVING_SP)
     ;
-  else if (flag_stack_check == GENERIC_STACK_CHECK)
+  else if (GCC_OPTION (flag_stack_check) == GENERIC_STACK_CHECK)
     probe_stack_range (STACK_OLD_CHECK_PROTECT + STACK_CHECK_MAX_FRAME_SIZE,
 		       size);
-  else if (flag_stack_check == STATIC_BUILTIN_STACK_CHECK)
+  else if (GCC_OPTION (flag_stack_check) == STATIC_BUILTIN_STACK_CHECK)
     probe_stack_range (STACK_CHECK_PROTECT, size);
 
   /* Don't let anti_adjust_stack emit notes.  */
@@ -1463,7 +1463,7 @@ allocate_dynamic_stack_space (rtx size, unsigned size_align,
 
       saved_stack_pointer_delta = stack_pointer_delta;
 
-      if (flag_stack_check && STACK_CHECK_MOVING_SP)
+      if (GCC_OPTION (flag_stack_check) && STACK_CHECK_MOVING_SP)
 	anti_adjust_stack_and_probe (size, false);
       else
 	anti_adjust_stack (size);
@@ -1483,7 +1483,7 @@ allocate_dynamic_stack_space (rtx size, unsigned size_align,
   /* Finish up the split stack handling.  */
   if (final_label != NULL_RTX)
     {
-      gcc_assert (flag_split_stack);
+      gcc_assert (GCC_OPTION (flag_split_stack));
       emit_move_insn (final_target, target);
       emit_label (final_label);
       target = final_target;
diff --git a/gcc/expmed.c b/gcc/expmed.c
index 7c1c979..c31137b 100644
--- a/gcc/expmed.c
+++ b/gcc/expmed.c
@@ -441,7 +441,7 @@ strict_volatile_bitfield_p (rtx op0, unsigned HOST_WIDE_INT bitsize,
      volatile MEM.  */
   if (!MEM_P (op0)
       || !MEM_VOLATILE_P (op0)
-      || flag_strict_volatile_bitfields <= 0)
+      || GCC_OPTION (flag_strict_volatile_bitfields) <= 0)
     return false;
 
   /* Non-integral modes likely only happen with packed structures.
@@ -2969,12 +2969,12 @@ expand_mult_const (enum machine_mode mode, rtx op0, HOST_WIDE_INT val,
   for (opno = 1; opno < alg->ops; opno++)
     {
       int log = alg->log[opno];
-      rtx shift_subtarget = optimize ? 0 : accum;
+      rtx shift_subtarget = GCC_OPTION (optimize) ? 0 : accum;
       rtx add_target
 	= (opno == alg->ops - 1 && target != 0 && variant != add_variant
-	   && !optimize)
+	   && !GCC_OPTION (optimize))
 	  ? target : 0;
-      rtx accum_target = optimize ? 0 : accum;
+      rtx accum_target = GCC_OPTION (optimize) ? 0 : accum;
       rtx accum_inner;
 
       switch (alg->op[opno])
@@ -3027,7 +3027,7 @@ expand_mult_const (enum machine_mode mode, rtx op0, HOST_WIDE_INT val,
 	  tem = expand_shift (LSHIFT_EXPR, mode, accum, log, NULL_RTX, 0);
 	  accum = force_operand (gen_rtx_MINUS (mode, tem, accum),
 				 (add_target
-				  ? add_target : (optimize ? 0 : tem)));
+				  ? add_target : (GCC_OPTION (optimize) ? 0 : tem)));
 	  val_so_far = (val_so_far << log) - val_so_far;
 	  break;
 
@@ -3097,7 +3097,7 @@ expand_mult (enum machine_mode mode, rtx op0, rtx op1, rtx target,
   rtx scalar_op1;
   int max_cost;
   bool speed = optimize_insn_for_speed_p ();
-  bool do_trapv = flag_trapv && SCALAR_INT_MODE_P (mode) && !unsignedp;
+  bool do_trapv = GCC_OPTION (flag_trapv) && SCALAR_INT_MODE_P (mode) && !unsignedp;
 
   if (CONSTANT_P (op0))
     {
@@ -3964,7 +3964,7 @@ expand_divmod (int rem_flag, enum tree_code code, enum machine_mode mode,
     {
       if (rem_flag)
 	return const0_rtx;
-      return expand_unop (mode, flag_trapv && GET_MODE_CLASS (mode) == MODE_INT
+      return expand_unop (mode, GCC_OPTION (flag_trapv) && GET_MODE_CLASS (mode) == MODE_INT
 			  ? negv_optab : neg_optab, op0, target, 0);
     }
 
@@ -5186,7 +5186,7 @@ emit_cstore (rtx target, enum insn_code icode, enum rtx_code code,
 
   comparison = gen_rtx_fmt_ee (code, result_mode, x, y);
 
-  create_output_operand (&ops[0], optimize ? NULL_RTX : target, result_mode);
+  create_output_operand (&ops[0], GCC_OPTION (optimize) ? NULL_RTX : target, result_mode);
   create_fixed_operand (&ops[1], comparison);
   create_fixed_operand (&ops[2], x);
   create_fixed_operand (&ops[3], y);
@@ -5218,7 +5218,7 @@ emit_cstore (rtx target, enum insn_code icode, enum rtx_code code,
 
   /* If we want to keep subexpressions around, don't reuse our last
      target.  */
-  if (optimize)
+  if (GCC_OPTION (optimize))
     subtarget = 0;
 
   /* Now normalize to the proper value in MODE.  Sometimes we don't
@@ -5510,7 +5510,7 @@ emit_store_flag (rtx target, enum rtx_code code, rtx op0, rtx op1,
   /* If optimizing, use different pseudo registers for each insn, instead
      of reusing the same pseudo.  This leads to better CSE, but slows
      down the compiler, since there are more pseudos */
-  subtarget = (!optimize
+  subtarget = (!GCC_OPTION (optimize)
 	       && (target_mode == mode)) ? target : NULL_RTX;
   trueval = GEN_INT (normalizep ? normalizep : STORE_FLAG_VALUE);
 
diff --git a/gcc/expr.c b/gcc/expr.c
index 2dcdfc2..c0775fc 100644
--- a/gcc/expr.c
+++ b/gcc/expr.c
@@ -502,7 +502,7 @@ convert_move (rtx to, rtx from, int unsignedp)
 	     so that we always generate the same set of insns for
 	     better cse'ing; if an intermediate assignment occurred,
 	     we won't be doing the operation directly on the SUBREG.  */
-	  if (optimize > 0 && GET_CODE (from) == SUBREG)
+	  if (GCC_OPTION (optimize) > 0 && GET_CODE (from) == SUBREG)
 	    from = force_reg (from_mode, from);
 	  emit_unop_insn (code, to, from, equiv_code);
 	  return;
@@ -3611,7 +3611,7 @@ emit_move_insn (rtx x, rtx y)
 
   if (CONSTANT_P (y))
     {
-      if (optimize
+      if (GCC_OPTION (optimize)
 	  && SCALAR_FLOAT_MODE_P (GET_MODE (x))
 	  && (last_insn = compress_float_constant (x, y)))
 	return last_insn;
@@ -4437,7 +4437,7 @@ emit_push_insn (rtx x, enum machine_mode mode, tree type, rtx size,
 static rtx
 get_subtarget (rtx x)
 {
-  return (optimize
+  return (GCC_OPTION (optimize)
           || x == 0
 	   /* Only registers can be subtargets.  */
 	   || !REG_P (x)
@@ -6710,7 +6710,7 @@ get_inner_reference (tree exp, HOST_WIDE_INT *pbitsize,
     {
       tree field = TREE_OPERAND (exp, 1);
       size_tree = DECL_SIZE (field);
-      if (flag_strict_volatile_bitfields > 0
+      if (GCC_OPTION (flag_strict_volatile_bitfields) > 0
 	  && TREE_THIS_VOLATILE (exp)
 	  && DECL_BIT_FIELD_TYPE (field)
 	  && DECL_MODE (field) != BLKmode)
@@ -7541,7 +7541,7 @@ expand_operands (tree exp0, tree exp1, rtx target, rtx *op0, rtx *op1,
     {
       /* If we need to preserve evaluation order, copy exp0 into its own
 	 temporary variable so that it can't be clobbered by exp1.  */
-      if (flag_evaluation_order && TREE_SIDE_EFFECTS (exp1))
+      if (GCC_OPTION (flag_evaluation_order) && TREE_SIDE_EFFECTS (exp1))
 	exp0 = save_expr (exp0);
       *op0 = expand_expr (exp0, target, VOIDmode, modifier);
       *op1 = expand_expr (exp1, NULL_RTX, VOIDmode, modifier);
@@ -8294,7 +8294,7 @@ expand_expr_real_2 (sepops ops, rtx target, enum machine_mode tmode,
 
 	 If this is an EXPAND_SUM call, always return the sum.  */
       if (modifier == EXPAND_SUM || modifier == EXPAND_INITIALIZER
-	  || (mode == ptr_mode && (unsignedp || ! flag_trapv)))
+	  || (mode == ptr_mode && (unsignedp || ! GCC_OPTION (flag_trapv))))
 	{
 	  if (modifier == EXPAND_STACK_PARM)
 	    target = 0;
@@ -8946,7 +8946,7 @@ expand_expr_real_2 (sepops ops, rtx target, enum machine_mode tmode,
 	   || ! safe_from_p (target, treeop1, 1)
 	   /* Make sure we don't have a hard reg (such as function's return
 	      value) live across basic blocks, if not optimizing.  */
-	   || (!optimize && REG_P (target)
+	   || (!GCC_OPTION (optimize) && REG_P (target)
 	       && REGNO (target) < FIRST_PSEUDO_REGISTER)))
 	target = gen_reg_rtx (tmode != VOIDmode ? tmode : mode);
 
@@ -9390,7 +9390,7 @@ expand_expr_real_1 (tree exp, rtx target, enum machine_mode tmode,
       if (g == NULL
 	  && modifier == EXPAND_INITIALIZER
 	  && !SSA_NAME_IS_DEFAULT_DEF (exp)
-	  && (optimize || DECL_IGNORED_P (SSA_NAME_VAR (exp)))
+	  && (GCC_OPTION (optimize) || DECL_IGNORED_P (SSA_NAME_VAR (exp)))
 	  && stmt_is_replaceable_p (SSA_NAME_DEF_STMT (exp)))
 	g = SSA_NAME_DEF_STMT (exp);
       if (g)
@@ -9832,7 +9832,7 @@ expand_expr_real_1 (tree exp, rtx target, enum machine_mode tmode,
 		}
 	  }
 
-	else if (optimize >= 1
+	else if (GCC_OPTION (optimize) >= 1
 		 && modifier != EXPAND_CONST_ADDRESS
 		 && modifier != EXPAND_INITIALIZER
 		 && modifier != EXPAND_MEMORY
@@ -11133,7 +11133,7 @@ do_tablejump (rtx index, enum machine_mode mode, rtx range, rtx table_label,
      out of PIC_CASE_VECTOR_ADDRESS won't be a valid address,
      and break_out_memory_refs will go to work on it and mess it up.  */
 #ifdef PIC_CASE_VECTOR_ADDRESS
-  if (flag_pic && !REG_P (index))
+  if (GCC_OPTION (flag_pic) && !REG_P (index))
     index = copy_to_mode_reg (Pmode, index);
 #endif
 
@@ -11147,7 +11147,7 @@ do_tablejump (rtx index, enum machine_mode mode, rtx range, rtx table_label,
 		   gen_int_mode (GET_MODE_SIZE (CASE_VECTOR_MODE), Pmode)),
      gen_rtx_LABEL_REF (Pmode, table_label));
 #ifdef PIC_CASE_VECTOR_ADDRESS
-  if (flag_pic)
+  if (GCC_OPTION (flag_pic))
     index = PIC_CASE_VECTOR_ADDRESS (index);
   else
 #endif
@@ -11160,7 +11160,7 @@ do_tablejump (rtx index, enum machine_mode mode, rtx range, rtx table_label,
 
   /* If we are generating PIC code or if the table is PC-relative, the
      table and JUMP_INSN must be adjacent, so don't output a BARRIER.  */
-  if (! CASE_VECTOR_PC_RELATIVE && ! flag_pic)
+  if (! CASE_VECTOR_PC_RELATIVE && ! GCC_OPTION (flag_pic))
     emit_barrier ();
 }
 
